Drill Down
If you bind a TreeMap to a data source with a hierarchical structure, you can enable drill-down and drill-up functionality:
- "Drill down" means navigate to a more detailed view.
- "Drill up" means navigate back up a level.
In this demo, you can click/tap a group of TreeMap tiles to drill down. Once you go down a level, navigation links appear at the top of the TreeMap. Use them to drill back up. To implement this technique, follow the steps below:
-
Set the interactWithGroup property to
true
to force the control to hot-track entire groups instead of individual items. -
Call the node.drillDown method in the TreeMap onClick handler.
-
To enable drill-up functionality, generate links in the onDrill handler. Call the node.drillDown method on link clicks. Inspect the code below for implementation details.
www.wikipedia.org
Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
$(() => {
$('#treemap').dxTreeMap({
dataSource: citiesPopulation,
size: {
height: 440,
},
title: {
text: 'The Most Populated Cities by Continents',
placeholderSize: 80,
},
colorizer: {
palette: 'soft',
},
interactWithGroup: true,
maxDepth: 2,
onClick(e) {
e.node.drillDown();
},
onDrill(e) {
const markup = $('#drill-down-title').empty();
let node;
for (node = e.node.getParent(); node; node = node.getParent()) {
markup.prepend(' > ').prepend($('<span />')
.addClass('link')
.text(node.label() || 'All Continents')
.data('node', node)
.on('dxclick', onLinkClick));
}
if (markup.children().length) {
markup.append(e.node.label());
}
},
});
function onLinkClick(e) {
$(e.target).data('node').drillDown();
}
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.6/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/23.1.6/js/dx.all.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="treemap"></div>
<div id="drill-down-title"></div>
</div>
</body>
</html>
#drill-down-title {
position: absolute;
top: 50px;
height: 36px;
width: 100%;
text-align: center;
}
.link {
color: #337ab7;
text-decoration: underline;
cursor: pointer;
}
const citiesPopulation = [{
name: 'Africa',
items: [{
name: 'Nigeria',
items: [{
name: 'Lagos',
value: 21324000,
}, {
name: 'Kano',
value: 3626068,
}, {
name: 'Ibadan',
value: 3200000,
}, {
name: 'Abuja',
value: 3000000,
}, {
name: 'Kaduna',
value: 1652844,
}, {
name: 'Port Harcourt',
value: 1320214,
}, {
name: 'Aba',
value: 1300000,
}, {
name: 'Ogbomosho',
value: 1200000,
}, {
name: 'Maiduguri',
value: 1197497,
}],
}, {
name: 'Egypt',
items: [{
name: 'Cairo',
value: 9278441,
}, {
name: 'Alexandria',
value: 4546231,
}, {
name: 'Giza',
value: 4239988,
}, {
name: 'Shubra El-Kheima',
value: 3072951,
}, {
name: 'Port Said',
value: 1607353,
}, {
name: 'Suez',
value: 1347352,
}],
}, {
name: 'Congo',
items: [{
name: 'Kinshasa',
value: 9735000,
}, {
name: 'Lubumbashi',
value: 1786397,
}, {
name: 'Mbuji-Mayi',
value: 1680991,
}, {
name: 'Kananga',
value: 1061181,
}, {
name: 'Bukavu',
value: 1012053,
}, {
name: 'Kisangani',
value: 935977,
}],
}, {
name: 'Morocco',
items: [{
name: 'Casablanca',
value: 3359818,
}, {
name: 'Fès',
value: 1112072,
}, {
name: 'Tangier',
value: 947952,
}, {
name: 'Marrakech',
value: 928850,
}, {
name: 'Salé',
value: 920403,
}],
}],
}, {
name: 'Asia',
items: [{
name: 'China',
items: [{
name: 'Shanghai',
value: 24256800,
}, {
name: 'Beijing',
value: 21516000,
}, {
name: 'Chongqing',
value: 18384100,
}, {
name: 'Chengdu',
value: 17677122,
}, {
name: 'Tianjin',
value: 15200000,
}, {
name: 'Guangzhou',
value: 13080500,
}, {
name: 'Shenzhen',
value: 10630000,
}],
}, {
name: 'Pakistan',
items: [{
name: 'Karachi',
value: 23500000,
}, {
name: 'Faisalabad',
value: 6418745,
}, {
name: 'Lahore',
value: 6318745,
}, {
name: 'Rawalpindi',
value: 3363911,
}, {
name: 'Hyderabad',
value: 3429471,
}, {
name: 'Multan',
value: 2050000,
}],
}, {
name: 'India',
items: [{
name: 'Delhi',
value: 16787941,
}, {
name: 'Mumbai',
value: 12478447,
}, {
name: 'Bengaluru',
value: 8425970,
}, {
name: 'Hyderabad',
value: 7749334,
}, {
name: 'Chennai',
value: 7088000,
}, {
name: 'Ahmedabad',
value: 5577940,
}],
}, {
name: 'Japan',
items: [{
name: 'Tokyo',
value: 9262046,
}, {
name: 'Yokohama',
value: 3697894,
}, {
name: 'Osaka',
value: 2668586,
}, {
name: 'Nagoya',
value: 2283289,
}, {
name: 'Sapporo',
value: 1918096,
}],
}],
}, {
name: 'Europe',
items: [{
name: 'Turkey',
items: [{
name: 'Istanbul',
value: 14160467,
}, {
name: 'Ankara',
value: 4470800,
}, {
name: 'İzmir',
value: 3276815,
}, {
name: 'Bursa',
value: 1957247,
}, {
name: 'Adana',
value: 1717473,
}],
}, {
name: 'Russia',
items: [{
name: 'Moscow',
value: 12197596,
}, {
name: 'Saint Petersburg',
value: 5191690,
}, {
name: 'Novosibirsk',
value: 1473754,
}, {
name: 'Yekaterinburg',
value: 1428042,
}],
}, {
name: 'United Kingdom',
items: [{
name: 'London',
value: 8538689,
}, {
name: 'Birmingham',
value: 1101360,
}, {
name: 'Glasgow',
value: 599650,
}, {
name: 'Liverpool',
value: 473073,
}],
}, {
name: 'Germany',
items: [{
name: 'Berlin',
value: 3517424,
}, {
name: 'Hamburg',
value: 1686100,
}, {
name: 'Munich',
value: 1185400,
}, {
name: 'Cologne',
value: 1046680,
}, {
name: 'Frankfurt',
value: 717624,
}],
}, {
name: 'France',
items: [{
name: 'Paris',
value: 2240621,
}, {
name: 'Marseille',
value: 852516,
}, {
name: 'Lyon',
value: 500715,
}, {
name: 'Toulouse',
value: 461190,
}],
}],
}, {
name: 'North America',
items: [{
name: 'Mexico',
items: [{
name: 'Mexico City',
value: 8874724,
}, {
name: 'Ecatepec de Morelos',
value: 1742023,
}, {
name: 'Puebla',
value: 1508707,
}, {
name: 'Guadalajara',
value: 1506359,
}, {
name: 'Juárez',
value: 1409987,
}, {
name: 'Tijuana',
value: 1399282,
}, {
name: 'León',
value: 1281434,
}],
}, {
name: 'United States',
items: [{
name: 'New York City',
value: 8550405,
}, {
name: 'Los Angeles',
value: 3884307,
}, {
name: 'Chicago',
value: 2722389,
}, {
name: 'Houston',
value: 2296224,
}, {
name: 'Philadelphia',
value: 1567442,
}, {
name: 'Phoenix',
value: 1563025,
}, {
name: 'San Antonio',
value: 1469845,
}, {
name: 'San Diego',
value: 1394928,
}],
}, {
name: 'Canada',
items: [{
name: 'Toronto',
value: 2808503,
}, {
name: 'Montreal',
value: 1731245,
}, {
name: 'Calgary',
value: 1096833,
}, {
name: 'Ottawa',
value: 956710,
}, {
name: 'Edmonton',
value: 895000,
}, {
name: 'Mississauga',
value: 713443,
}],
}, {
name: 'Cuba',
items: [{
name: 'Havana',
value: 2135498,
}, {
name: 'Santiago de Cuba',
value: 425851,
}, {
name: 'Camagüey',
value: 305845,
}],
}],
}, {
name: 'South America',
items: [{
name: 'Brazil',
items: [{
name: 'São Paulo',
value: 11895893,
}, {
name: 'Rio de Janeiro',
value: 6429923,
}, {
name: 'Salvador',
value: 2902927,
}, {
name: 'Brasília',
value: 2914830,
}, {
name: 'Fortaleza',
value: 2591188,
}, {
name: 'Belo Horizonte',
value: 2513451,
}, {
name: 'Manaus',
value: 2094391,
}],
}, {
name: 'Peru',
items: [{
name: 'Lima',
value: 8693387,
}, {
name: 'Callao',
value: 1010315,
}, {
name: 'Arequipa',
value: 869351,
}, {
name: 'Trujillo',
value: 788236,
}, {
name: 'Chiclayo',
value: 600440,
}],
}, {
name: 'Colombia',
items: [{
name: 'Bogotá',
value: 7776845,
}, {
name: 'Medellín',
value: 2441123,
}, {
name: 'Cali',
value: 2400653,
}, {
name: 'Barranquilla',
value: 1214253,
}, {
name: 'Cartagena',
value: 959594,
}],
}, {
name: 'Chile',
items: [{
name: 'Santiago',
value: 5507282,
}, {
name: 'Puente Alto',
value: 610118,
}, {
name: 'Maipú',
value: 468390,
}],
}, {
name: 'Venezuela',
items: [{
name: 'Caracas',
value: 3289886,
}, {
name: 'Maracaibo',
value: 1653211,
}, {
name: 'Barquisimeto',
value: 1116182,
}, {
name: 'Valencia',
value: 901900,
}, {
name: 'Ciudad Guayana',
value: 877547,
}],
}],
}];

If you have technical questions, please create a support ticket in the DevExpress Support Center.
import React, { useCallback, useState } from 'react';
import TreeMap, {
Size, Title, Colorizer, TreeMapTypes,
} from 'devextreme-react/tree-map';
import { DrillInfo, citiesPopulation } from './data.ts';
import TreeMapBreadcrumbs from './TreeMapBreadcrumbs.tsx';
function drillInfoClick(node: DrillInfo['node']) {
if (node) {
node.drillDown();
}
}
function nodeClick(e: TreeMapTypes.ClickEvent) {
e.node.drillDown();
}
function App() {
const [drillInfo, setDrillInfo] = useState<DrillInfo[]>([]);
const drill = useCallback((e: TreeMapTypes.DrillEvent) => {
const newDrillInfo = [];
for (let node = e.node.getParent(); node; node = node.getParent()) {
newDrillInfo.unshift({
text: node.label() || 'All Continents',
node,
});
}
if (newDrillInfo.length) {
newDrillInfo.push({
text: e.node.label(),
});
}
setDrillInfo(newDrillInfo);
}, [setDrillInfo]);
return (
<React.Fragment>
<TreeMap
dataSource={citiesPopulation}
interactWithGroup={true}
maxDepth={2}
onClick={nodeClick}
onDrill={drill}
>
<Size height={440} />
<Colorizer palette="Soft" />
<Title
text="The Most Populated Cities by Continents"
placeholderSize={80}
/>
</TreeMap>
<TreeMapBreadcrumbs
className="drill-down-title"
onItemClick={drillInfoClick}
treeInfo={drillInfo}
/>
</React.Fragment>
);
}
export default App;
xxxxxxxxxx
import React, { useCallback, useState } from 'react';
import TreeMap, { Size, Title, Colorizer } from 'devextreme-react/tree-map';
import { citiesPopulation } from './data.js';
import TreeMapBreadcrumbs from './TreeMapBreadcrumbs.js';
function drillInfoClick(node) {
if (node) {
node.drillDown();
}
}
function nodeClick(e) {
e.node.drillDown();
}
function App() {
const [drillInfo, setDrillInfo] = useState([]);
const drill = useCallback(
(e) => {
const newDrillInfo = [];
for (let node = e.node.getParent(); node; node = node.getParent()) {
newDrillInfo.unshift({
text: node.label() || 'All Continents',
node,
});
}
if (newDrillInfo.length) {
newDrillInfo.push({
text: e.node.label(),
});
}
setDrillInfo(newDrillInfo);
},
[setDrillInfo],
);
return (
<React.Fragment>
<TreeMap
dataSource={citiesPopulation}
interactWithGroup={true}
maxDepth={2}
onClick={nodeClick}
onDrill={drill}
>
<Size height={440} />
<Colorizer palette="Soft" />
<Title
text="The Most Populated Cities by Continents"
placeholderSize={80}
/>
</TreeMap>
<TreeMapBreadcrumbs
className="drill-down-title"
onItemClick={drillInfoClick}
treeInfo={drillInfo}
/>
</React.Fragment>
);
}
export default App;
xxxxxxxxxx
import React, { useCallback } from 'react';
import { DrillInfo } from './data';
interface BreadcrumbProps {
key: string;
onClick: (props: DrillInfo['node']) => void;
info: DrillInfo;
isLast: boolean;
}
function Breadcrumb(props: BreadcrumbProps) {
const onClick = useCallback(() => {
props.onClick(props.info.node);
}, [props]);
return (
<span>
<span
className={props.info.node ? 'link' : ''}
onClick={onClick}
>
{props.info.text}
</span>
{props.isLast ? '' : ' > '}
</span>
);
}
export default Breadcrumb;
xxxxxxxxxx
import React from 'react';
import Breadcrumb from './Breadcrumb.tsx';
import { DrillInfo } from './data.ts';
interface TreeMapBreadcrumbsProps {
className: string;
onItemClick: (node: DrillInfo['node']) => void;
treeInfo: DrillInfo[];
}
function TreeMapBreadcrumbs({ className, treeInfo, onItemClick }: TreeMapBreadcrumbsProps) {
const lastIndex = treeInfo.length - 1;
return (
<div className={className}>
{
treeInfo.map((info, index: number) => (
<Breadcrumb
key={info.text}
onClick={onItemClick}
info={info}
isLast={index === lastIndex} />
))
}
</div>
);
}
export default TreeMapBreadcrumbs;
xxxxxxxxxx
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
xxxxxxxxxx
import { TreeMapTypes } from 'devextreme-react/tree-map';
export type DrillInfo = { text?: string, node?: TreeMapTypes.DrillEvent['node'] };
export const citiesPopulation = [{
name: 'Africa',
items: [{
name: 'Nigeria',
items: [{
name: 'Lagos',
value: 21324000,
}, {
name: 'Kano',
value: 3626068,
}, {
name: 'Ibadan',
value: 3200000,
}, {
name: 'Abuja',
value: 3000000,
}, {
name: 'Kaduna',
value: 1652844,
}, {
name: 'Port Harcourt',
value: 1320214,
}, {
name: 'Aba',
value: 1300000,
}, {
name: 'Ogbomosho',
value: 1200000,
}, {
name: 'Maiduguri',
value: 1197497,
}],
}, {
name: 'Egypt',
items: [{
name: 'Cairo',
value: 9278441,
}, {
name: 'Alexandria',
value: 4546231,
}, {
name: 'Giza',
value: 4239988,
}, {
name: 'Shubra El-Kheima',
value: 3072951,
}, {
name: 'Port Said',
value: 1607353,
}, {
name: 'Suez',
value: 1347352,
}],
}, {
name: 'Congo',
items: [{
name: 'Kinshasa',
value: 9735000,
}, {
name: 'Lubumbashi',
value: 1786397,
}, {
name: 'Mbuji-Mayi',
value: 1680991,
}, {
name: 'Kananga',
value: 1061181,
}, {
name: 'Bukavu',
value: 1012053,
}, {
name: 'Kisangani',
value: 935977,
}],
}, {
name: 'Morocco',
items: [{
name: 'Casablanca',
value: 3359818,
}, {
name: 'Fès',
value: 1112072,
}, {
name: 'Tangier',
value: 947952,
}, {
name: 'Marrakech',
value: 928850,
}, {
name: 'Salé',
value: 920403,
}],
}],
}, {
name: 'Asia',
items: [{
name: 'China',
items: [{
name: 'Shanghai',
value: 24256800,
}, {
name: 'Beijing',
value: 21516000,
}, {
name: 'Chongqing',
value: 18384100,
}, {
name: 'Chengdu',
value: 17677122,
}, {
name: 'Tianjin',
value: 15200000,
}, {
name: 'Guangzhou',
value: 13080500,
}, {
name: 'Shenzhen',
value: 10630000,
}],
}, {
name: 'Pakistan',
items: [{
name: 'Karachi',
value: 23500000,
}, {
name: 'Faisalabad',
value: 6418745,
}, {
name: 'Lahore',
value: 6318745,
}, {
name: 'Rawalpindi',
value: 3363911,
}, {
name: 'Hyderabad',
value: 3429471,
}, {
name: 'Multan',
value: 2050000,
}],
}, {
name: 'India',
items: [{
name: 'Delhi',
value: 16787941,
}, {
name: 'Mumbai',
value: 12478447,
}, {
name: 'Bengaluru',
value: 8425970,
}, {
name: 'Hyderabad',
value: 7749334,
}, {
name: 'Chennai',
value: 7088000,
}, {
name: 'Ahmedabad',
value: 5577940,
}],
}, {
name: 'Japan',
items: [{
name: 'Tokyo',
value: 9262046,
}, {
name: 'Yokohama',
value: 3697894,
}, {
name: 'Osaka',
value: 2668586,
}, {
name: 'Nagoya',
value: 2283289,
}, {
name: 'Sapporo',
value: 1918096,
}],
}],
}, {
name: 'Europe',
items: [{
name: 'Turkey',
items: [{
name: 'Istanbul',
value: 14160467,
}, {
name: 'Ankara',
value: 4470800,
}, {
name: 'İzmir',
value: 3276815,
}, {
name: 'Bursa',
value: 1957247,
}, {
name: 'Adana',
value: 1717473,
}],
}, {
name: 'Russia',
items: [{
name: 'Moscow',
value: 12197596,
}, {
name: 'Saint Petersburg',
value: 5191690,
}, {
name: 'Novosibirsk',
value: 1473754,
}, {
name: 'Yekaterinburg',
value: 1428042,
}],
}, {
name: 'United Kingdom',
items: [{
name: 'London',
value: 8538689,
}, {
name: 'Birmingham',
value: 1101360,
}, {
name: 'Glasgow',
value: 599650,
}, {
name: 'Liverpool',
value: 473073,
}],
}, {
name: 'Germany',
items: [{
name: 'Berlin',
value: 3517424,
}, {
name: 'Hamburg',
value: 1686100,
}, {
name: 'Munich',
value: 1185400,
}, {
name: 'Cologne',
value: 1046680,
}, {
name: 'Frankfurt',
value: 717624,
}],
}, {
name: 'France',
items: [{
name: 'Paris',
value: 2240621,
}, {
name: 'Marseille',
value: 852516,
}, {
name: 'Lyon',
value: 500715,
}, {
name: 'Toulouse',
value: 461190,
}],
}],
}, {
name: 'North America',
items: [{
name: 'Mexico',
items: [{
name: 'Mexico City',
value: 8874724,
}, {
name: 'Ecatepec de Morelos',
value: 1742023,
}, {
name: 'Puebla',
value: 1508707,
}, {
name: 'Guadalajara',
value: 1506359,
}, {
name: 'Juárez',
value: 1409987,
}, {
name: 'Tijuana',
value: 1399282,
}, {
name: 'León',
value: 1281434,
}],
}, {
name: 'United States',
items: [{
name: 'New York City',
value: 8550405,
}, {
name: 'Los Angeles',
value: 3884307,
}, {
name: 'Chicago',
value: 2722389,
}, {
name: 'Houston',
value: 2296224,
}, {
name: 'Philadelphia',
value: 1567442,
}, {
name: 'Phoenix',
value: 1563025,
}, {
name: 'San Antonio',
value: 1469845,
}, {
name: 'San Diego',
value: 1394928,
}],
}, {
name: 'Canada',
items: [{
name: 'Toronto',
value: 2808503,
}, {
name: 'Montreal',
value: 1731245,
}, {
name: 'Calgary',
value: 1096833,
}, {
name: 'Ottawa',
value: 956710,
}, {
name: 'Edmonton',
value: 895000,
}, {
name: 'Mississauga',
value: 713443,
}],
}, {
name: 'Cuba',
items: [{
name: 'Havana',
value: 2135498,
}, {
name: 'Santiago de Cuba',
value: 425851,
}, {
name: 'Camagüey',
value: 305845,
}],
}],
}, {
name: 'South America',
items: [{
name: 'Brazil',
items: [{
name: 'São Paulo',
value: 11895893,
}, {
name: 'Rio de Janeiro',
value: 6429923,
}, {
name: 'Salvador',
value: 2902927,
}, {
name: 'Brasília',
value: 2914830,
}, {
name: 'Fortaleza',
value: 2591188,
}, {
name: 'Belo Horizonte',
value: 2513451,
}, {
name: 'Manaus',
value: 2094391,
}],
}, {
name: 'Peru',
items: [{
name: 'Lima',
value: 8693387,
}, {
name: 'Callao',
value: 1010315,
}, {
name: 'Arequipa',
value: 869351,
}, {
name: 'Trujillo',
value: 788236,
}, {
name: 'Chiclayo',
value: 600440,
}],
}, {
name: 'Colombia',
items: [{
name: 'Bogotá',
value: 7776845,
}, {
name: 'Medellín',
value: 2441123,
}, {
name: 'Cali',
value: 2400653,
}, {
name: 'Barranquilla',
value: 1214253,
}, {
name: 'Cartagena',
value: 959594,
}],
}, {
name: 'Chile',
items: [{
name: 'Santiago',
value: 5507282,
}, {
name: 'Puente Alto',
value: 610118,
}, {
name: 'Maipú',
value: 468390,
}],
}, {
name: 'Venezuela',
items: [{
name: 'Caracas',
value: 3289886,
}, {
name: 'Maracaibo',
value: 1653211,
}, {
name: 'Barquisimeto',
value: 1116182,
}, {
name: 'Valencia',
value: 901900,
}, {
name: 'Ciudad Guayana',
value: 877547,
}],
}],
}];
xxxxxxxxxx
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
'bundles:': 'bundles/',
'externals:': 'bundles/externals/',
},
defaultExtension: 'js',
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@24.2.5/cjs',
'devextreme-react': 'npm:devextreme-react@24.2.5/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.1/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.15/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.59/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);
xxxxxxxxxx
import React, { useCallback } from 'react';
function Breadcrumb(props) {
const onClick = useCallback(() => {
props.onClick(props.info.node);
}, [props]);
return (
<span>
<span
className={props.info.node ? 'link' : ''}
onClick={onClick}
>
{props.info.text}
</span>
{props.isLast ? '' : ' > '}
</span>
);
}
export default Breadcrumb;
xxxxxxxxxx
import React from 'react';
import Breadcrumb from './Breadcrumb.js';
function TreeMapBreadcrumbs({ className, treeInfo, onItemClick }) {
const lastIndex = treeInfo.length - 1;
return (
<div className={className}>
{treeInfo.map((info, index) => (
<Breadcrumb
key={info.text}
onClick={onItemClick}
info={info}
isLast={index === lastIndex}
/>
))}
</div>
);
}
export default TreeMapBreadcrumbs;
xxxxxxxxxx
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
xxxxxxxxxx
export const citiesPopulation = [
{
name: 'Africa',
items: [
{
name: 'Nigeria',
items: [
{
name: 'Lagos',
value: 21324000,
},
{
name: 'Kano',
value: 3626068,
},
{
name: 'Ibadan',
value: 3200000,
},
{
name: 'Abuja',
value: 3000000,
},
{
name: 'Kaduna',
value: 1652844,
},
{
name: 'Port Harcourt',
value: 1320214,
},
{
name: 'Aba',
value: 1300000,
},
{
name: 'Ogbomosho',
value: 1200000,
},
{
name: 'Maiduguri',
value: 1197497,
},
],
},
{
name: 'Egypt',
items: [
{
name: 'Cairo',
value: 9278441,
},
{
name: 'Alexandria',
value: 4546231,
},
{
name: 'Giza',
value: 4239988,
},
{
name: 'Shubra El-Kheima',
value: 3072951,
},
{
name: 'Port Said',
value: 1607353,
},
{
name: 'Suez',
value: 1347352,
},
],
},
{
name: 'Congo',
items: [
{
name: 'Kinshasa',
value: 9735000,
},
{
name: 'Lubumbashi',
value: 1786397,
},
{
name: 'Mbuji-Mayi',
value: 1680991,
},
{
name: 'Kananga',
value: 1061181,
},
{
name: 'Bukavu',
value: 1012053,
},
{
name: 'Kisangani',
value: 935977,
},
],
},
{
name: 'Morocco',
items: [
{
name: 'Casablanca',
value: 3359818,
},
{
name: 'Fès',
value: 1112072,
},
{
name: 'Tangier',
value: 947952,
},
{
name: 'Marrakech',
value: 928850,
},
{
name: 'Salé',
value: 920403,
},
],
},
],
},
{
name: 'Asia',
items: [
{
name: 'China',
items: [
{
name: 'Shanghai',
value: 24256800,
},
{
name: 'Beijing',
value: 21516000,
},
{
name: 'Chongqing',
value: 18384100,
},
{
name: 'Chengdu',
value: 17677122,
},
{
name: 'Tianjin',
value: 15200000,
},
{
name: 'Guangzhou',
value: 13080500,
},
{
name: 'Shenzhen',
value: 10630000,
},
],
},
{
name: 'Pakistan',
items: [
{
name: 'Karachi',
value: 23500000,
},
{
name: 'Faisalabad',
value: 6418745,
},
{
name: 'Lahore',
value: 6318745,
},
{
name: 'Rawalpindi',
value: 3363911,
},
{
name: 'Hyderabad',
value: 3429471,
},
{
name: 'Multan',
value: 2050000,
},
],
},
{
name: 'India',
items: [
{
name: 'Delhi',
value: 16787941,
},
{
name: 'Mumbai',
value: 12478447,
},
{
name: 'Bengaluru',
value: 8425970,
},
{
name: 'Hyderabad',
value: 7749334,
},
{
name: 'Chennai',
value: 7088000,
},
{
name: 'Ahmedabad',
value: 5577940,
},
],
},
{
name: 'Japan',
items: [
{
name: 'Tokyo',
value: 9262046,
},
{
name: 'Yokohama',
value: 3697894,
},
{
name: 'Osaka',
value: 2668586,
},
{
name: 'Nagoya',
value: 2283289,
},
{
name: 'Sapporo',
value: 1918096,
},
],
},
],
},
{
name: 'Europe',
items: [
{
name: 'Turkey',
items: [
{
name: 'Istanbul',
value: 14160467,
},
{
name: 'Ankara',
value: 4470800,
},
{
name: 'İzmir',
value: 3276815,
},
{
name: 'Bursa',
value: 1957247,
},
{
name: 'Adana',
value: 1717473,
},
],
},
{
name: 'Russia',
items: [
{
name: 'Moscow',
value: 12197596,
},
{
name: 'Saint Petersburg',
value: 5191690,
},
{
name: 'Novosibirsk',
value: 1473754,
},
{
name: 'Yekaterinburg',
value: 1428042,
},
],
},
{
name: 'United Kingdom',
items: [
{
name: 'London',
value: 8538689,
},
{
name: 'Birmingham',
value: 1101360,
},
{
name: 'Glasgow',
value: 599650,
},
{
name: 'Liverpool',
value: 473073,
},
],
},
{
name: 'Germany',
items: [
{
name: 'Berlin',
value: 3517424,
},
{
name: 'Hamburg',
value: 1686100,
},
{
name: 'Munich',
value: 1185400,
},
{
name: 'Cologne',
value: 1046680,
},
{
name: 'Frankfurt',
value: 717624,
},
],
},
{
name: 'France',
items: [
{
name: 'Paris',
value: 2240621,
},
{
name: 'Marseille',
value: 852516,
},
{
name: 'Lyon',
value: 500715,
},
{
name: 'Toulouse',
value: 461190,
},
],
},
],
},
{
name: 'North America',
items: [
{
name: 'Mexico',
items: [
{
name: 'Mexico City',
value: 8874724,
},
{
name: 'Ecatepec de Morelos',
value: 1742023,
},
{
name: 'Puebla',
value: 1508707,
},
{
name: 'Guadalajara',
value: 1506359,
},
{
name: 'Juárez',
value: 1409987,
},
{
name: 'Tijuana',
value: 1399282,
},
{
name: 'León',
value: 1281434,
},
],
},
{
name: 'United States',
items: [
{
name: 'New York City',
value: 8550405,
},
{
name: 'Los Angeles',
value: 3884307,
},
{
name: 'Chicago',
value: 2722389,
},
{
name: 'Houston',
value: 2296224,
},
{
name: 'Philadelphia',
value: 1567442,
},
{
name: 'Phoenix',
value: 1563025,
},
{
name: 'San Antonio',
value: 1469845,
},
{
name: 'San Diego',
value: 1394928,
},
],
},
{
name: 'Canada',
items: [
{
name: 'Toronto',
value: 2808503,
},
{
name: 'Montreal',
value: 1731245,
},
{
name: 'Calgary',
value: 1096833,
},
{
name: 'Ottawa',
value: 956710,
},
{
name: 'Edmonton',
value: 895000,
},
{
name: 'Mississauga',
value: 713443,
},
],
},
{
name: 'Cuba',
items: [
{
name: 'Havana',
value: 2135498,
},
{
name: 'Santiago de Cuba',
value: 425851,
},
{
name: 'Camagüey',
value: 305845,
},
],
},
],
},
{
name: 'South America',
items: [
{
name: 'Brazil',
items: [
{
name: 'São Paulo',
value: 11895893,
},
{
name: 'Rio de Janeiro',
value: 6429923,
},
{
name: 'Salvador',
value: 2902927,
},
{
name: 'Brasília',
value: 2914830,
},
{
name: 'Fortaleza',
value: 2591188,
},
{
name: 'Belo Horizonte',
value: 2513451,
},
{
name: 'Manaus',
value: 2094391,
},
],
},
{
name: 'Peru',
items: [
{
name: 'Lima',
value: 8693387,
},
{
name: 'Callao',
value: 1010315,
},
{
name: 'Arequipa',
value: 869351,
},
{
name: 'Trujillo',
value: 788236,
},
{
name: 'Chiclayo',
value: 600440,
},
],
},
{
name: 'Colombia',
items: [
{
name: 'Bogotá',
value: 7776845,
},
{
name: 'Medellín',
value: 2441123,
},
{
name: 'Cali',
value: 2400653,
},
{
name: 'Barranquilla',
value: 1214253,
},
{
name: 'Cartagena',
value: 959594,
},
],
},
{
name: 'Chile',
items: [
{
name: 'Santiago',
value: 5507282,
},
{
name: 'Puente Alto',
value: 610118,
},
{
name: 'Maipú',
value: 468390,
},
],
},
{
name: 'Venezuela',
items: [
{
name: 'Caracas',
value: 3289886,
},
{
name: 'Maracaibo',
value: 1653211,
},
{
name: 'Barquisimeto',
value: 1116182,
},
{
name: 'Valencia',
value: 901900,
},
{
name: 'Ciudad Guayana',
value: 877547,
},
],
},
],
},
];
xxxxxxxxxx
<html lang="en">
<head></head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
xxxxxxxxxx
.drill-down-title {
position: absolute;
top: 50px;
height: 36px;
width: 100%;
text-align: center;
}
.link {
color: #337ab7;
text-decoration: underline;
cursor: pointer;
}
In this demo, you can click/tap a group of TreeMap tiles to drill down. Once you go down a level, navigation links appear at the top of the TreeMap. Use them to drill back up. To implement this technique, follow the steps below:
-
Set the interactWithGroup property to
true
to force the control to hot-track entire groups instead of individual items. -
Call the node.drillDown method in the TreeMap onClick handler.
-
To enable drill-up functionality, generate links in the onDrill handler. Call the node.drillDown method on link clicks. Inspect the code below for implementation details.

<template>
<div>
<DxTreeMap
:data-source="citiesPopulation"
:interact-with-group="true"
:max-depth="2"
@click="nodeClick"
@drill="drill"
>
<DxSize :height="440"/>
<DxColorizer palette="Soft"/>
<DxTitle
:placeholder-size="80"
text="The Most Populated Cities by Continents"
/>
</DxTreeMap>
<div id="drill-down-title">
<span
v-for="(info, index) in drillInfo"
:key="index"
>
<span
:class="{'link': !!info.node}"
@click="drillInfoClick(info.node)"
>{{ info.text }}</span>
<span v-if="index !== drillInfo.length - 1"> > </span>
</span>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import DxTreeMap, {
DxSize, DxTitle, DxColorizer, type DxTreeMapTypes,
} from 'devextreme-vue/tree-map';
import { citiesPopulation } from './data.ts';
const drillInfo = ref<Record<string, any>[]>([]);
function nodeClick({ node }: DxTreeMapTypes.ClickEvent) {
node.drillDown();
}
function drill(e: DxTreeMapTypes.DrillEvent) {
drillInfo.value = [];
for (let node = e.node.getParent(); node; node = node.getParent()) {
drillInfo.value.unshift({
text: node.label() || 'All Continents',
node,
});
}
if (drillInfo.value.length) {
drillInfo.value.push({
text: e.node.label(),
});
}
}
function drillInfoClick(node: Record<string, any>) {
node?.drillDown();
}
</script>
<style>
#drill-down-title {
position: absolute;
top: 50px;
height: 36px;
width: 100%;
text-align: center;
}
.link {
color: #337ab7;
text-decoration: underline;
cursor: pointer;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export const citiesPopulation = [{
name: 'Africa',
items: [{
name: 'Nigeria',
items: [{
name: 'Lagos',
value: 21324000,
}, {
name: 'Kano',
value: 3626068,
}, {
name: 'Ibadan',
value: 3200000,
}, {
name: 'Abuja',
value: 3000000,
}, {
name: 'Kaduna',
value: 1652844,
}, {
name: 'Port Harcourt',
value: 1320214,
}, {
name: 'Aba',
value: 1300000,
}, {
name: 'Ogbomosho',
value: 1200000,
}, {
name: 'Maiduguri',
value: 1197497,
}],
}, {
name: 'Egypt',
items: [{
name: 'Cairo',
value: 9278441,
}, {
name: 'Alexandria',
value: 4546231,
}, {
name: 'Giza',
value: 4239988,
}, {
name: 'Shubra El-Kheima',
value: 3072951,
}, {
name: 'Port Said',
value: 1607353,
}, {
name: 'Suez',
value: 1347352,
}],
}, {
name: 'Congo',
items: [{
name: 'Kinshasa',
value: 9735000,
}, {
name: 'Lubumbashi',
value: 1786397,
}, {
name: 'Mbuji-Mayi',
value: 1680991,
}, {
name: 'Kananga',
value: 1061181,
}, {
name: 'Bukavu',
value: 1012053,
}, {
name: 'Kisangani',
value: 935977,
}],
}, {
name: 'Morocco',
items: [{
name: 'Casablanca',
value: 3359818,
}, {
name: 'Fès',
value: 1112072,
}, {
name: 'Tangier',
value: 947952,
}, {
name: 'Marrakech',
value: 928850,
}, {
name: 'Salé',
value: 920403,
}],
}],
}, {
name: 'Asia',
items: [{
name: 'China',
items: [{
name: 'Shanghai',
value: 24256800,
}, {
name: 'Beijing',
value: 21516000,
}, {
name: 'Chongqing',
value: 18384100,
}, {
name: 'Chengdu',
value: 17677122,
}, {
name: 'Tianjin',
value: 15200000,
}, {
name: 'Guangzhou',
value: 13080500,
}, {
name: 'Shenzhen',
value: 10630000,
}],
}, {
name: 'Pakistan',
items: [{
name: 'Karachi',
value: 23500000,
}, {
name: 'Faisalabad',
value: 6418745,
}, {
name: 'Lahore',
value: 6318745,
}, {
name: 'Rawalpindi',
value: 3363911,
}, {
name: 'Hyderabad',
value: 3429471,
}, {
name: 'Multan',
value: 2050000,
}],
}, {
name: 'India',
items: [{
name: 'Delhi',
value: 16787941,
}, {
name: 'Mumbai',
value: 12478447,
}, {
name: 'Bengaluru',
value: 8425970,
}, {
name: 'Hyderabad',
value: 7749334,
}, {
name: 'Chennai',
value: 7088000,
}, {
name: 'Ahmedabad',
value: 5577940,
}],
}, {
name: 'Japan',
items: [{
name: 'Tokyo',
value: 9262046,
}, {
name: 'Yokohama',
value: 3697894,
}, {
name: 'Osaka',
value: 2668586,
}, {
name: 'Nagoya',
value: 2283289,
}, {
name: 'Sapporo',
value: 1918096,
}],
}],
}, {
name: 'Europe',
items: [{
name: 'Turkey',
items: [{
name: 'Istanbul',
value: 14160467,
}, {
name: 'Ankara',
value: 4470800,
}, {
name: 'İzmir',
value: 3276815,
}, {
name: 'Bursa',
value: 1957247,
}, {
name: 'Adana',
value: 1717473,
}],
}, {
name: 'Russia',
items: [{
name: 'Moscow',
value: 12197596,
}, {
name: 'Saint Petersburg',
value: 5191690,
}, {
name: 'Novosibirsk',
value: 1473754,
}, {
name: 'Yekaterinburg',
value: 1428042,
}],
}, {
name: 'United Kingdom',
items: [{
name: 'London',
value: 8538689,
}, {
name: 'Birmingham',
value: 1101360,
}, {
name: 'Glasgow',
value: 599650,
}, {
name: 'Liverpool',
value: 473073,
}],
}, {
name: 'Germany',
items: [{
name: 'Berlin',
value: 3517424,
}, {
name: 'Hamburg',
value: 1686100,
}, {
name: 'Munich',
value: 1185400,
}, {
name: 'Cologne',
value: 1046680,
}, {
name: 'Frankfurt',
value: 717624,
}],
}, {
name: 'France',
items: [{
name: 'Paris',
value: 2240621,
}, {
name: 'Marseille',
value: 852516,
}, {
name: 'Lyon',
value: 500715,
}, {
name: 'Toulouse',
value: 461190,
}],
}],
}, {
name: 'North America',
items: [{
name: 'Mexico',
items: [{
name: 'Mexico City',
value: 8874724,
}, {
name: 'Ecatepec de Morelos',
value: 1742023,
}, {
name: 'Puebla',
value: 1508707,
}, {
name: 'Guadalajara',
value: 1506359,
}, {
name: 'Juárez',
value: 1409987,
}, {
name: 'Tijuana',
value: 1399282,
}, {
name: 'León',
value: 1281434,
}],
}, {
name: 'United States',
items: [{
name: 'New York City',
value: 8550405,
}, {
name: 'Los Angeles',
value: 3884307,
}, {
name: 'Chicago',
value: 2722389,
}, {
name: 'Houston',
value: 2296224,
}, {
name: 'Philadelphia',
value: 1567442,
}, {
name: 'Phoenix',
value: 1563025,
}, {
name: 'San Antonio',
value: 1469845,
}, {
name: 'San Diego',
value: 1394928,
}],
}, {
name: 'Canada',
items: [{
name: 'Toronto',
value: 2808503,
}, {
name: 'Montreal',
value: 1731245,
}, {
name: 'Calgary',
value: 1096833,
}, {
name: 'Ottawa',
value: 956710,
}, {
name: 'Edmonton',
value: 895000,
}, {
name: 'Mississauga',
value: 713443,
}],
}, {
name: 'Cuba',
items: [{
name: 'Havana',
value: 2135498,
}, {
name: 'Santiago de Cuba',
value: 425851,
}, {
name: 'Camagüey',
value: 305845,
}],
}],
}, {
name: 'South America',
items: [{
name: 'Brazil',
items: [{
name: 'São Paulo',
value: 11895893,
}, {
name: 'Rio de Janeiro',
value: 6429923,
}, {
name: 'Salvador',
value: 2902927,
}, {
name: 'Brasília',
value: 2914830,
}, {
name: 'Fortaleza',
value: 2591188,
}, {
name: 'Belo Horizonte',
value: 2513451,
}, {
name: 'Manaus',
value: 2094391,
}],
}, {
name: 'Peru',
items: [{
name: 'Lima',
value: 8693387,
}, {
name: 'Callao',
value: 1010315,
}, {
name: 'Arequipa',
value: 869351,
}, {
name: 'Trujillo',
value: 788236,
}, {
name: 'Chiclayo',
value: 600440,
}],
}, {
name: 'Colombia',
items: [{
name: 'Bogotá',
value: 7776845,
}, {
name: 'Medellín',
value: 2441123,
}, {
name: 'Cali',
value: 2400653,
}, {
name: 'Barranquilla',
value: 1214253,
}, {
name: 'Cartagena',
value: 959594,
}],
}, {
name: 'Chile',
items: [{
name: 'Santiago',
value: 5507282,
}, {
name: 'Puente Alto',
value: 610118,
}, {
name: 'Maipú',
value: 468390,
}],
}, {
name: 'Venezuela',
items: [{
name: 'Caracas',
value: 3289886,
}, {
name: 'Maracaibo',
value: 1653211,
}, {
name: 'Barquisimeto',
value: 1116182,
}, {
name: 'Valencia',
value: 901900,
}, {
name: 'Ciudad Guayana',
value: 877547,
}],
}],
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

Backend API
<dx-tree-map
[dataSource]="citiesPopulations"
[interactWithGroup]="true"
[maxDepth]="2"
(onClick)="nodeClick($event)"
(onDrill)="drill($event)"
>
<dxo-tree-map-size height="440"></dxo-tree-map-size>
<dxo-tree-map-title
text="The Most Populated Cities by Continents"
[placeholderSize]="80"
></dxo-tree-map-title>
<dxo-tree-map-colorizer palette="soft"></dxo-tree-map-colorizer>
</dx-tree-map>
<div id="drill-down-title">
@for(drillInfo of drillInfos; track drillInfo; let isLast = $last) {
<span>
<span
[class.link]="!!drillInfo.node"
(click)="drillInfoClick(drillInfo.node)"
>{{ drillInfo.text }}</span
>
{{ isLast ? "" : " > " }}
</span>
}
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxTreeMapModule } from 'devextreme-angular';
import { CitiesPopulation, Service } from './app.service';
interface DrillInfo {
text: string;
node?: Element;
}
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxTreeMapModule,
],
})
export class AppComponent {
citiesPopulations: CitiesPopulation[];
drillInfos: DrillInfo[] = [];
constructor(service: Service) {
this.citiesPopulations = service.getCitiesPopulations();
}
nodeClick(e) {
e.node.drillDown();
}
drill(e) {
this.drillInfos = [];
for (let node = e.node.getParent(); node; node = node.getParent()) {
this.drillInfos.unshift({
text: node.label() || 'All Continents',
node,
});
}
if (this.drillInfos.length) {
this.drillInfos.push({
text: e.node.label(),
});
}
}
drillInfoClick(node) {
if (node) {
node.drillDown();
}
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #drill-down-title {
position: absolute;
top: 50px;
height: 36px;
width: 100%;
text-align: center;
}
::ng-deep .link {
color: #337ab7;
text-decoration: underline;
cursor: pointer;
}
import { Injectable } from '@angular/core';
export interface CitiesPopulation {
name: string;
items: Record<string, unknown>[];
}
const citiesPopulations: CitiesPopulation[] = [{
name: 'Africa',
items: [{
name: 'Nigeria',
items: [{
name: 'Lagos',
value: 21324000,
}, {
name: 'Kano',
value: 3626068,
}, {
name: 'Ibadan',
value: 3200000,
}, {
name: 'Abuja',
value: 3000000,
}, {
name: 'Kaduna',
value: 1652844,
}, {
name: 'Port Harcourt',
value: 1320214,
}, {
name: 'Aba',
value: 1300000,
}, {
name: 'Ogbomosho',
value: 1200000,
}, {
name: 'Maiduguri',
value: 1197497,
}],
}, {
name: 'Egypt',
items: [{
name: 'Cairo',
value: 9278441,
}, {
name: 'Alexandria',
value: 4546231,
}, {
name: 'Giza',
value: 4239988,
}, {
name: 'Shubra El-Kheima',
value: 3072951,
}, {
name: 'Port Said',
value: 1607353,
}, {
name: 'Suez',
value: 1347352,
}],
}, {
name: 'Congo',
items: [{
name: 'Kinshasa',
value: 9735000,
}, {
name: 'Lubumbashi',
value: 1786397,
}, {
name: 'Mbuji-Mayi',
value: 1680991,
}, {
name: 'Kananga',
value: 1061181,
}, {
name: 'Bukavu',
value: 1012053,
}, {
name: 'Kisangani',
value: 935977,
}],
}, {
name: 'Morocco',
items: [{
name: 'Casablanca',
value: 3359818,
}, {
name: 'Fès',
value: 1112072,
}, {
name: 'Tangier',
value: 947952,
}, {
name: 'Marrakech',
value: 928850,
}, {
name: 'Salé',
value: 920403,
}],
}],
}, {
name: 'Asia',
items: [{
name: 'China',
items: [{
name: 'Shanghai',
value: 24256800,
}, {
name: 'Beijing',
value: 21516000,
}, {
name: 'Chongqing',
value: 18384100,
}, {
name: 'Chengdu',
value: 17677122,
}, {
name: 'Tianjin',
value: 15200000,
}, {
name: 'Guangzhou',
value: 13080500,
}, {
name: 'Shenzhen',
value: 10630000,
}],
}, {
name: 'Pakistan',
items: [{
name: 'Karachi',
value: 23500000,
}, {
name: 'Faisalabad',
value: 6418745,
}, {
name: 'Lahore',
value: 6318745,
}, {
name: 'Rawalpindi',
value: 3363911,
}, {
name: 'Hyderabad',
value: 3429471,
}, {
name: 'Multan',
value: 2050000,
}],
}, {
name: 'India',
items: [{
name: 'Delhi',
value: 16787941,
}, {
name: 'Mumbai',
value: 12478447,
}, {
name: 'Bengaluru',
value: 8425970,
}, {
name: 'Hyderabad',
value: 7749334,
}, {
name: 'Chennai',
value: 7088000,
}, {
name: 'Ahmedabad',
value: 5577940,
}],
}, {
name: 'Japan',
items: [{
name: 'Tokyo',
value: 9262046,
}, {
name: 'Yokohama',
value: 3697894,
}, {
name: 'Osaka',
value: 2668586,
}, {
name: 'Nagoya',
value: 2283289,
}, {
name: 'Sapporo',
value: 1918096,
}],
}],
}, {
name: 'Europe',
items: [{
name: 'Turkey',
items: [{
name: 'Istanbul',
value: 14160467,
}, {
name: 'Ankara',
value: 4470800,
}, {
name: 'İzmir',
value: 3276815,
}, {
name: 'Bursa',
value: 1957247,
}, {
name: 'Adana',
value: 1717473,
}],
}, {
name: 'Russia',
items: [{
name: 'Moscow',
value: 12197596,
}, {
name: 'Saint Petersburg',
value: 5191690,
}, {
name: 'Novosibirsk',
value: 1473754,
}, {
name: 'Yekaterinburg',
value: 1428042,
}],
}, {
name: 'United Kingdom',
items: [{
name: 'London',
value: 8538689,
}, {
name: 'Birmingham',
value: 1101360,
}, {
name: 'Glasgow',
value: 599650,
}, {
name: 'Liverpool',
value: 473073,
}],
}, {
name: 'Germany',
items: [{
name: 'Berlin',
value: 3517424,
}, {
name: 'Hamburg',
value: 1686100,
}, {
name: 'Munich',
value: 1185400,
}, {
name: 'Cologne',
value: 1046680,
}, {
name: 'Frankfurt',
value: 717624,
}],
}, {
name: 'France',
items: [{
name: 'Paris',
value: 2240621,
}, {
name: 'Marseille',
value: 852516,
}, {
name: 'Lyon',
value: 500715,
}, {
name: 'Toulouse',
value: 461190,
}],
}],
}, {
name: 'North America',
items: [{
name: 'Mexico',
items: [{
name: 'Mexico City',
value: 8874724,
}, {
name: 'Ecatepec de Morelos',
value: 1742023,
}, {
name: 'Puebla',
value: 1508707,
}, {
name: 'Guadalajara',
value: 1506359,
}, {
name: 'Juárez',
value: 1409987,
}, {
name: 'Tijuana',
value: 1399282,
}, {
name: 'León',
value: 1281434,
}],
}, {
name: 'United States',
items: [{
name: 'New York City',
value: 8550405,
}, {
name: 'Los Angeles',
value: 3884307,
}, {
name: 'Chicago',
value: 2722389,
}, {
name: 'Houston',
value: 2296224,
}, {
name: 'Philadelphia',
value: 1567442,
}, {
name: 'Phoenix',
value: 1563025,
}, {
name: 'San Antonio',
value: 1469845,
}, {
name: 'San Diego',
value: 1394928,
}],
}, {
name: 'Canada',
items: [{
name: 'Toronto',
value: 2808503,
}, {
name: 'Montreal',
value: 1731245,
}, {
name: 'Calgary',
value: 1096833,
}, {
name: 'Ottawa',
value: 956710,
}, {
name: 'Edmonton',
value: 895000,
}, {
name: 'Mississauga',
value: 713443,
}],
}, {
name: 'Cuba',
items: [{
name: 'Havana',
value: 2135498,
}, {
name: 'Santiago de Cuba',
value: 425851,
}, {
name: 'Camagüey',
value: 305845,
}],
}],
}, {
name: 'South America',
items: [{
name: 'Brazil',
items: [{
name: 'São Paulo',
value: 11895893,
}, {
name: 'Rio de Janeiro',
value: 6429923,
}, {
name: 'Salvador',
value: 2902927,
}, {
name: 'Brasília',
value: 2914830,
}, {
name: 'Fortaleza',
value: 2591188,
}, {
name: 'Belo Horizonte',
value: 2513451,
}, {
name: 'Manaus',
value: 2094391,
}],
}, {
name: 'Peru',
items: [{
name: 'Lima',
value: 8693387,
}, {
name: 'Callao',
value: 1010315,
}, {
name: 'Arequipa',
value: 869351,
}, {
name: 'Trujillo',
value: 788236,
}, {
name: 'Chiclayo',
value: 600440,
}],
}, {
name: 'Colombia',
items: [{
name: 'Bogotá',
value: 7776845,
}, {
name: 'Medellín',
value: 2441123,
}, {
name: 'Cali',
value: 2400653,
}, {
name: 'Barranquilla',
value: 1214253,
}, {
name: 'Cartagena',
value: 959594,
}],
}, {
name: 'Chile',
items: [{
name: 'Santiago',
value: 5507282,
}, {
name: 'Puente Alto',
value: 610118,
}, {
name: 'Maipú',
value: 468390,
}],
}, {
name: 'Venezuela',
items: [{
name: 'Caracas',
value: 3289886,
}, {
name: 'Maracaibo',
value: 1653211,
}, {
name: 'Barquisimeto',
value: 1116182,
}, {
name: 'Valencia',
value: 901900,
}, {
name: 'Ciudad Guayana',
value: 877547,
}],
}],
}];
@Injectable()
export class Service {
getCitiesPopulations() {
return citiesPopulations;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.2.11"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
In this demo, you can click/tap a group of TreeMap tiles to drill down. Once you go down a level, navigation links appear at the top of the TreeMap. Use them to drill back up. To implement this technique, follow the steps below:
-
Set the interactWithGroup property to
trueto force the control to hot-track entire groups instead of individual items. -
Call the node.drillDown method in the TreeMap onClick handler.
-
To enable drill-up functionality, generate links in the onDrill handler. Call the node.drillDown method on link clicks. Inspect the code below for implementation details.